<?php
/*
$Id: paymentpartner_cc_xml.php
osCommerce, Open Source E-Commerce Solutions
http://www.oscommerce.com
Copyright (c) 2003 osCommerce / STAPIS GmbH
Released under the GNU General Public License
*/
class paymentpartner_cc_xml {
  var $code, $title, $description, $enabled;
// class constructor
  function paymentpartner_cc_xml() {
    global $order;
    $this->code = 'paymentpartner_cc_xml';
    $this->title = MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_TITLE;
    $this->description = MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_DESCRIPTION;
    $this->sort_order = MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_SORT_ORDER;
    $this->enabled = ((MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_STATUS == 'True') ? true : false);
    if ((int)MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_ORDER_STATUS_ID > 0) {
      $this->order_status = MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_ORDER_STATUS_ID;
    }
    if (is_object($order)) $this->update_status();
  }
// class methods
  function update_status() {
    global $order;
    if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_ZONE > 0) ) {
      $check_flag = false;
      $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
      while ($check = tep_db_fetch_array($check_query)) {
        if ($check['zone_id'] < 1) {
          $check_flag = true;
          break;
        } elseif ($check['zone_id'] == $order->billing['zone_id']) {
          $check_flag = true;
          break;
        }
      }
      if ($check_flag == false) {
        $this->enabled = false;
      }
    }
  }
  function javascript_validation() {
    $js = '  if (payment_value == "' . $this->code . '") {' . "\n" .
          '    var cc_owner = document.checkout_payment.paymentpartner_cc_xml_owner.value;' . "\n" .
          '    var cc_number = document.checkout_payment.paymentpartner_cc_xml_number.value;' . "\n" .
          '    var cc_code = document.checkout_payment.paymentpartner_cc_xml_checkcode.value;' . "\n" .
          '    if (cc_owner == "" || cc_owner.length < ' . CC_OWNER_MIN_LENGTH . ') {' . "\n" .
          '      error_message = error_message + "' . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_JS_CC_OWNER . '";' . "\n" .
          '      error = 1;' . "\n" .
          '    }' . "\n" .
          '    if (cc_number == "" || cc_number.length < ' . CC_NUMBER_MIN_LENGTH . ') {' . "\n" .
          '      error_message = error_message + "' . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_JS_CC_NUMBER . '";' . "\n" .
          '      error = 1;' . "\n" .
          '    }' . "\n" .
          '    if (cc_code == "" || cc_code.length < 3) {' . "\n" .
          '      error_message = error_message + "' . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_JS_CC_CODE . '";' . "\n" .
          '      error = 1;' . "\n" .
          '    }' . "\n" .
          '  }' . "\n";
    return $js;
  }
  function selection() {
    global $order;
    for ($i=1; $i < 13; $i++) {
      $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
    }
    $today = getdate(); 
    for ($i=$today['year']; $i < $today['year']+10; $i++) {
      $expires_year[] = array('id' => strftime('%Y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
    }
    $card_type[] = array('id' => 'AMEX', 'text' => 'American Express');
    $card_type[] = array('id' => 'MASTER', 'text' => 'Mastercard');
    $card_type[] = array('id' => 'VISA', 'text' => 'VISA');
    $selection = array('id' => $this->code,
                       'module' => $this->title,
                       'fields' => array(array('title' => MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_CREDIT_CARD_OWNER,
                                               'field' => tep_draw_input_field('paymentpartner_cc_xml_owner', $order->billing['firstname'] . ' ' . $order->billing['lastname'], 'onclick="selectRowEffect(this, 2)"')),
                                         array('title' => MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_CREDIT_CARD_TYPE,
                                               'field' => tep_draw_pull_down_menu('paymentpartner_cc_xml_type', $card_type)),
                                         array('title' => MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_CREDIT_CARD_NUMBER,
                                               'field' => tep_draw_input_field('paymentpartner_cc_xml_number', '','onclick="selectRowEffect(this, 2)"')),
                                         array('title' => MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_CREDIT_CARD_EXPIRES,
                                               'field' => tep_draw_pull_down_menu('paymentpartner_cc_xml_expires_month', $expires_month) . '&nbsp;' . tep_draw_pull_down_menu('paymentpartner_cc_xml_expires_year', $expires_year)),
                                         array('title' => MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_CREDIT_CARD_CHECKNUMBER,
                                               'field' => tep_draw_input_field('paymentpartner_cc_xml_checkcode', '', 'size="5" maxlength="4"') . '&nbsp;<small>' . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT_CREDIT_CARD_CHECKNUMBER_LOCATION . '</small>')));
    return $selection;
  }
  function pre_confirmation_check() {
    return false;
  }
  function confirmation() {
    return false;
  }
  function process_button() {
    $process_button_string = tep_draw_hidden_field('paymentpartner_cc_xml_owner', $HTTP_POST_VARS['paymentpartner_cc_xml_owner']) .
                             tep_draw_hidden_field('paymentpartner_cc_xml_type', $HTTP_POST_VARS['paymentpartner_cc_xml_type']) .
                             tep_draw_hidden_field('paymentpartner_cc_xml_number', $HTTP_POST_VARS['paymentpartner_cc_xml_number']) .
                             tep_draw_hidden_field('paymentpartner_cc_xml_expires_month', $HTTP_POST_VARS['paymentpartner_cc_xml_expires_month']) .
                             tep_draw_hidden_field('paymentpartner_cc_xml_expires_year', $HTTP_POST_VARS['paymentpartner_cc_xml_expires_year']) .
                             tep_draw_hidden_field('paymentpartner_cc_xml_checkcode', $HTTP_POST_VARS['paymentpartner_cc_xml_checkcode']);
    return $process_button_string;
  }
  function before_process() {
    global $order, $HTTP_POST_VARS;
    include_once (DIR_FS_CATALOG . DIR_WS_INCLUDES . "xml-integrator.php");
    if (MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_MODUS == "Test") {
      $paymentpartner_cc_mode = 'INTEGRATOR_TEST';
      $payment_partner_cc_url = 'test.ctpe.io';
    } else {
      $paymentpartner_cc_mode = 'LIVE';
      $payment_partner_cc_url = 'ctpe.io';
    }
    $paymentpcc = new _ctpexmlpost($payment_partner_cc_url, '/payment/ctpe', MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_SENDER, MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_CHANNEL, MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_USER,MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_PASS,$paymentpartner_cc_mode,'SYNC');
    $paymentpcc->setAccountInformation($HTTP_POST_VARS[paymentpartner_cc_xml_owner],$HTTP_POST_VARS['paymentpartner_cc_xml_type'],$HTTP_POST_VARS[paymentpartner_cc_xml_number],'','','',$HTTP_POST_VARS[paymentpartner_cc_xml_checkcode],$HTTP_POST_VARS[paymentpartner_cc_xml_expires_year],$HTTP_POST_VARS[paymentpartner_cc_xml_expires_month]);
    $paymentpcc->setPaymentCode('CC.DB');
    $paymentpcc->setPaymentInformation(number_format($order->info['total'], 2, '.',''),STORE_NAME,$order_id,'EUR');
    $paymentpcc->setCustomerContact($order->customer['email_address'],'',getenv('REMOTE_ADDR'),$order->customer['telephone']);
    $paymentpcc->setCustomerAddress($order->billing['street_address'],$order->billing['post_code'],$order->billing['city'],$order->billing['state'],$order->billing['country']['iso_code_2']);
    $paymentpcc->setCustomerName('','',$order->billing['firstname'],$order->billing['lastname'],'');
    $output=$paymentpcc->commitXMLPayment();
    unset ($paymentpcc);
    if ($output) {
      if ($output != "ACK") {
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'message=' . urlencode($output), 'SSL'));
      }
    } else {
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'message=connection_problem', 'SSL'));
    }
    return false;
  }
  function after_process() {
    return false;
  }
  function get_error() {
    return false;
  }
  function check() {
    if (!isset($this->_check)) {
      $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_STATUS'");
      $this->_check = tep_db_num_rows($check_query);
    }
    return $this->_check;
  }
  function install() {
    global $language;
    include(DIR_FS_CATALOG_LANGUAGES . $language . '/modules/payment/paymentpartner_cc_xml.php');
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT1A . "', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_STATUS', 'True', '" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT1B . "', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT2A . "', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_MODUS', 'Test', '" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT2B . "', '6', '2', 'tep_cfg_select_option(array(\'Test\', \'Live\'), ', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT3A . "', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_SENDER', '', '" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT3B . "', '6', '3', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT4A . "', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_CHANNEL', '', '" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT4B . "', '6', '4', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT5A . "', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_USER', '', '" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT5B . "', '6', '5', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT6A . "', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_PASS', '', '" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT6B . "', '6', '6', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT7A . "', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_SORT_ORDER', '0', '" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT7B . "', '6', '7', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT8A . "', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_ZONE', '0', '" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT8B . "', '6', '8', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT9A . "', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_ORDER_STATUS_ID', '0', '" . MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_TEXT9A . "', '6', '9', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
  }
  function remove() {
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
  }
  function keys() {
    return array('MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_STATUS', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_MODUS', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_SENDER', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_CHANNEL', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_USER', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_PASS', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_ZONE', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYMENTPARTNER_CC_XML_SORT_ORDER');
  }
}
?>
